function varargout = getsamps_devel(varargin)
% GETSAMPS_DEVEL M-file for getsamps_devel.fig
%      GETSAMPS_DEVEL, by itself, creates a new GETSAMPS_DEVEL or raises the existing
%      singleton*.
%
%      [SAMPLES, NAMES, ISAMPLED] = GETSAMPS_DEVEL returns the burn-removed samples info
%      SAMPLES, with column names NAMES as specified when running GETSAMPS_DEVEL
%
%      SAMPLES is just the burn-removed contents of the samples files.
%      NAMES is a cell array containing the column names
%      ISAMPLED is an array of the column numbers worth plotting
%
%      GETSAMPS_DEVEL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in GETSAMPS_DEVEL.M with the given input arguments.
%
%      GETSAMPS_DEVEL('Property','Value',...) creates a new GETSAMPS_DEVEL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before getsamps_devel_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to getsamps_devel_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help getsamps_devel

% Last Modified by GUIDE v2.5 16-Jun-2004 14:45:07

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @getsamps_devel_OpeningFcn, ...
                   'gui_OutputFcn',  @getsamps_devel_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before getsamps_devel is made visible.
function getsamps_devel_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to getsamps_devel (see VARARGIN)

% set default handles associated with reading in samples file
handles.sampsdir= '../chains/'; % default samples directory
handles.namesdir= './'; % default names directory
handles.namesfile= 'CMB.names'; % default names filename
handles.nburn= 1000; % default number to burn
handles.nthin=10; % default thinning factor
samplesfiles=''; % ??

fid=fopen('getsamps_devel_prefs.mat');
if (fid>0)
    fclose(fid);
    htmp=load('getsamps_devel_prefs'); % sampsdir namesdir namesfile nburn nthin filescell
    % NB. loading the above into handles wipes the handles struct !
    % is there a way to add elements to a struct from another struct?
    % ie. handles= concatstruct(handles,htmp) or something? 
    % maybe could write one?
    handles.sampsdir=htmp.sampsdir;
    handles.namesdir=htmp.namesdir;
    handles.namesfile=htmp.namesfile;
    handles.nburn=htmp.nburn;
    handles.nthin=htmp.nthin;
    samplesfiles=htmp.samplesfiles;
    usefiles=htmp.usefiles;
end
    
set(handles.NamesButton,'String',[handles.namesfile]);
set(handles.NoBurnEdit,'String',num2str(handles.nburn));
set(handles.NoThinEdit,'String',num2str(handles.nthin));
set(handles.SamplesFilesListbox,'String',samplesfiles);
if (exist('usefiles'))
    set(handles.SamplesFilesListbox,'Value',usefiles);
end

% set default output values 
handles.samples = -1; % the contents of the samples file (ie. nothing yet..)
handles.names = 'Not known yet'; % the names of the columns (dummy)
handles.isampled= -1; % the columns worth plotting

% Update handles structure
guidata(hObject, handles);

%% bring up the file browser immediately - will definitely want it!
%AddSamplesFilesButton_Callback(hObject, eventdata, handles)
% can't do this here, it seems, as this confuses it..

% UIWAIT makes getsamps_devel wait for user response (see UIRESUME)
% uiwait(handles.getsamps_devel);
uiwait; % don't let it assign the output arguments until we've got them


% --- Outputs from this function are returned to the command line.
function varargout = getsamps_devel_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
if (isempty(handles))
    varargout{1} = -1;
    varargout{2} = 'Not known yet';
    varargout{3} = -1;
    varargout{4}=-1;
else    
    varargout{1} = handles.samples;
    varargout{2} = handles.names;
    varargout{3} = handles.isampled;
    if sum(sum(handles.samples~=-1))
        varargout{4} = gcf;
    else
        varargout{4}=-1;
    end
end

    
% --- Executes on button press in AddSamplesFilesButton.
function AddSamplesFilesButton_Callback(hObject, eventdata, handles)
% hObject    handle to AddSamplesFilesButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[file,path] = uigetfile([handles.sampsdir,'*.txt']);
if ~isequal(file, 0)
    %open(file);
    handles.sampsdir=path; % probs will want to use this next time too
    oldfiles=get(handles.SamplesFilesListbox,'String');
    newfiles=strvcat(oldfiles,[path,file]);
    tmp=size(newfiles);
    nfiles=tmp(1);
    if (nfiles>get(handles.SamplesFilesListbox,'Max'))
        set(handles.SamplesFilesListbox,'Max',nfiles+10); 
        % why not just increasing as reqd.
%        fprintf(1,'Error: need to increase Max for Listbox SamplesFileList')
    end
    set(handles.SamplesFilesListbox,'String',newfiles);
    % highlight the new entry as well as previously highlighted entries
    set(handles.SamplesFilesListbox,'Value',...
        [get(handles.SamplesFilesListbox,'Value') nfiles]);
end

% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function SamplesFilesListbox_CreateFcn(hObject, eventdata, handles)
% hObject    handle to SamplesFilesListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --- Executes on selection change in SamplesFilesListbox.
function SamplesFilesListbox_Callback(hObject, eventdata, handles)
% hObject    handle to SamplesFilesListbox (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns SamplesFilesListbox contents as cell array
%        contents{get(hObject,'Value')} returns selected item from SamplesFilesListbox


% --- Executes on button press in NamesButton.
function NamesButton_Callback(hObject, eventdata, handles)
% hObject    handle to NamesButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[file,path] = uigetfile([handles.namesdir,'*.names']);
if ~isequal(file, 0)
    handles.namesdir=path;
    handles.namesfile=file;
    set(handles.NamesButton,'String',[handles.namesfile]);
end

% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function NoBurnEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to NoBurnEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --- Executes on changing number in NoBurnEdit box
function NoBurnEdit_Callback(hObject, eventdata, handles)
% do nothing

% --- Executes on button press in LoadButton.
function LoadButton_Callback(hObject, eventdata, handles)
% hObject    handle to LoadButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

handles.nburn=str2double(get(handles.NoBurnEdit,'String'));
handles.nthin=str2double(get(handles.NoThinEdit,'String'));
handles.filescell=cellstr(get(handles.SamplesFilesListbox,'String'));

% get rid of repetitions in 
% get(handles.SamplesFilesListbox,'Value')
% why does this happen? Surely we would never want it.
vals=get(handles.SamplesFilesListbox,'Value');
iin=1;
for i=2:length(vals)
    if ~(vals(i)==vals(i-1))
        iin=[iin i];
    end
end

goodfile=0;
while (goodfile~=1)
[handles.samples,handles.names]=readsampsf( ...
    handles.filescell(vals(iin)), ...
    [handles.namesdir,handles.namesfile],...
    handles.nburn,handles.nthin);
    if isempty(handles.samples)
        fprintf('ERROR: No samples were stored\n')
        return;
    end
    if (length(handles.samples)>100)
        goodfile=1;
    else
        fprintf(1,'ERROR: File contains less than 100 lines!\n')
        return
%        AddSamplesfile_Callback(hObject,eventdata,handles);
    end    
end

% find out which columns are sampled from and which are fixed
handles.isampled=find(min(handles.samples,[],2)-max(handles.samples,[],2));
% we don't want to include the second column
% (also will change meaning of request for first column)
handles.isampled=handles.isampled([1 3:length(handles.isampled)]);
% don't include any columns that don't have names
tmp=size(handles.names);
handles.isampled=handles.isampled(find(handles.isampled<=tmp(1)));

guidata(hObject,handles); % store the changes

% save the inputs to a file for next-time
% annoying.. I can't put bits of structures to save..
% how can I do the below (and corresponding read in..) better?
sampsdir=handles.sampsdir;
namesdir=handles.namesdir;
namesfile=handles.namesfile;
nburn=handles.nburn;
nthin=handles.nthin;
samplesfiles=get(handles.SamplesFilesListbox,'String');
usefiles=get(handles.SamplesFilesListbox,'Value');
save getsamps_devel_prefs sampsdir namesdir namesfile nburn nthin samplesfiles usefiles

uiresume; % OK, can now assign the output arguments now we've finished


% --- Executes on key press over getsamps_devel with no controls selected.
function getsamps_devel_KeyPressFcn(hObject, eventdata, handles)
% hObject    handle to getsamps_devel (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% if a button is pressed at any time within this window, just make this
% equivalent to ...

% hmm, what if this window isn't called getsamps_devel ??

cchar=get(gcf,'CurrentCharacter');
fprintf(1,['currentchar=',cchar,'\n'])
if (cchar=='q')
    close(gcf)
elseif (cchar=='a')
    AddSamplesFilesButton_Callback(hObject, eventdata, handles)
elseif (cchar=='l')
    LoadButton_Callback(hObject, eventdata, handles)
end

% whatever character is pressed, load the data
% (would ideally like this to happen only if `return' is pressed..
%  but how to check for this character?)
%LoadButton_Callback(hObject, eventdata, handles)


% --- Executes on button press in RemovePush.
function RemovePush_Callback(hObject, eventdata, handles)
% hObject    handle to RemovePush (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

samplesfiles=get(handles.SamplesFilesListbox,'String');
tmp=size(samplesfiles);
nfiles=tmp(1);

% remove all the highlighted files from the list
removefiles=get(handles.SamplesFilesListbox,'Value');
usefiles=[];
for i=1:nfiles
    if (~sum(i==removefiles))
        usefiles=[usefiles i]
    end
end

set(handles.SamplesFilesListbox,'String',samplesfiles(usefiles,:))
set(handles.SamplesFilesListbox,'Value',1); % ? anything more sensible?


% --- Executes on button press in cancelbutton.
function cancelbutton_Callback(hObject, eventdata, handles)
% hObject    handle to cancelbutton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

close(gcf)


% --- Executes during object creation, after setting all properties.
function NoThinEdit_CreateFcn(hObject, eventdata, handles)
% hObject    handle to NoThinEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end



function NoThinEdit_Callback(hObject, eventdata, handles)
% hObject    handle to NoThinEdit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of NoThinEdit as text
%        str2double(get(hObject,'String')) returns contents of NoThinEdit as a double


